#Boa:Frame:MainFrame

license = """****************************************************************************
  glext2_gui.py - GLExtension data/class file generator with GUI
  -------------------------------------------------------------------------

  Copyright (C) 2005 Matthaeus G. Chajdas

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 2 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place, Suite 330, Boston, MA 02111-1307 USA
  
  This software depends on GLEW (http://glew.sourceforge.net).
  GLEW's autogeneration tools are licensed under the GPL, while GLEW itself
  is licensed under SGI Free Software License B and the GLX Public License.
****************************************************************************
"""

from wxPython.wx import *
from wxPython.lib.dialogs import wxScrolledMessageDialog

from xml.dom import minidom
from string import *
import string
from os import *
import re
import xml.dom.minidom
from xml.dom.minidom import *

def create(parent):
    return MainFrame(parent)

[wxID_MAINFRAME, wxID_MAINFRAMECOPYRIGHT, wxID_MAINFRAMECURRENTPROGRESS, 
 wxID_MAINFRAMEGENHEADER, wxID_MAINFRAMELICENSE, wxID_MAINFRAMELOGLABEL, 
 wxID_MAINFRAMEPRG1, wxID_MAINFRAMEPRG2, wxID_MAINFRAMEPROGRESSBOX, 
 wxID_MAINFRAMESTATICLINE1, wxID_MAINFRAMETEXT1, 
 wxID_MAINFRAMETOTALPROGRESSLABEL, wxID_MAINFRAMEXML_GEN, 
] = map(lambda _init_ctrls: wxNewId(), range(13))

class MainFrame(wxFrame):
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wxFrame.__init__(self, id=wxID_MAINFRAME, name=u'MainFrame',
              parent=prnt, pos=wxPoint(412, 356), size=wxSize(640, 480),
              style=wxCAPTION | wxSYSTEM_MENU | wxCLOSE_BOX,
              title=u'GL Extension file/class generator...')
        self.SetClientSize(wxSize(632, 449))
        self.SetBackgroundColour(wxColour(244, 243, 240))

        self.Prg1 = wxGauge(id=wxID_MAINFRAMEPRG1, name=u'Prg1', parent=self,
              pos=wxPoint(16, 368), range=100, size=wxSize(600, 24),
              style=wxGA_HORIZONTAL)

        self.GenHeader = wxButton(id=wxID_MAINFRAMEGENHEADER,
              label=u'Generate .h', name=u'GenHeader', parent=self,
              pos=wxPoint(104, 416), size=wxSize(88, 23), style=0)
        EVT_BUTTON(self.GenHeader, wxID_MAINFRAMEGENHEADER,
              self.OnGenHeaderButton)

        self.Text1 = wxTextCtrl(id=wxID_MAINFRAMETEXT1, name=u'Text1',
              parent=self, pos=wxPoint(8, 24), size=wxSize(616, 264),
              style=wxTE_MULTILINE, value=u'')
        self.Text1.SetThemeEnabled(True)

        self.Prg2 = wxGauge(id=wxID_MAINFRAMEPRG2, name=u'Prg2', parent=self,
              pos=wxPoint(16, 336), range=100, size=wxSize(600, 12),
              style=wxGA_HORIZONTAL)

        self.TotalProgressLabel = wxStaticText(id=wxID_MAINFRAMETOTALPROGRESSLABEL,
              label=u'Total progress', name=u'TotalProgressLabel', parent=self,
              pos=wxPoint(16, 352), size=wxSize(600, 16), style=0)

        self.CurrentProgress = wxStaticText(id=wxID_MAINFRAMECURRENTPROGRESS,
              label=u'CurrentProgress', name=u'CurrentProgress', parent=self,
              pos=wxPoint(16, 320), size=wxSize(600, 13), style=0)

        self.LogLabel = wxStaticText(id=wxID_MAINFRAMELOGLABEL, label=u'Output',
              name=u'LogLabel', parent=self, pos=wxPoint(8, 8), size=wxSize(34,
              13), style=0)

        self.Copyright = wxStaticText(id=wxID_MAINFRAMECOPYRIGHT,
              label=u'Copyright (C) Matthaeus G. "Anteru" Chajdas',
              name=u'Copyright', parent=self, pos=wxPoint(404, 432),
              size=wxSize(324, 13), style=0)

        self.ProgressBox = wxStaticBox(id=wxID_MAINFRAMEPROGRESSBOX,
              label=u'Status', name=u'ProgressBox', parent=self, pos=wxPoint(8,
              304), size=wxSize(616, 100), style=0)

        self.XML_Gen = wxButton(id=wxID_MAINFRAMEXML_GEN, label=u'Generate XML',
              name=u'XML_Gen', parent=self, pos=wxPoint(8, 416), size=wxSize(88,
              23), style=0)
        EVT_BUTTON(self.XML_Gen, wxID_MAINFRAMEXML_GEN, self.OnXML_GenButton)

        self.License = wxButton(id=wxID_MAINFRAMELICENSE, label=u'Show license',
              name=u'License', parent=self, pos=wxPoint(208, 416),
              size=wxSize(88, 23), style=0)
        EVT_BUTTON(self.License, wxID_MAINFRAMELICENSE, self.OnLicenseButton)

        self.staticLine1 = wxStaticLine(id=wxID_MAINFRAMESTATICLINE1,
              name='staticLine1', parent=self, pos=wxPoint(200, 408),
              size=wxSize(2, 40), style=0)

    def __init__(self, parent):
        self._init_ctrls(parent)
        self.out_window = True

    def SetWindowOutput (self, window = True):
        self.out_window = window

    def OnGenHeaderButton (self, event):
        self.SetCursor (wxHOURGLASS_CURSOR)
        self.Text1.Clear ()
        ProcessXML (self)
        self.SetCursor (wxSTANDARD_CURSOR)
        
    def Print (self,text=""):
        if self.out_window:
            self.Text1.AppendText (text)
            self.Text1.AppendText (u"\r\n")
        else:
            print text
        
    def ProgressCaption (self, text):
        self.CurrentProgress.SetLabel (text)
        
    def ProgressTotal (self, value):
        if self.out_window:
            self.Prg1.SetValue (int(value))
    
    def ProgressCurrent (self, value):
        if self.out_window:
            self.Prg2.SetValue (int(value))

    def OnXML_GenButton(self, event):
        self.SetCursor (wxHOURGLASS_CURSOR)
        self.Text1.Clear ()
        CreateXML (self)
        self.SetCursor (wxSTANDARD_CURSOR)

    def OnLicenseButton(self, event):
        dlg = wxScrolledMessageDialog (self, license, "License")
        dlg.ShowModal ()

        
# Create Header from XML        
def ProcessXML (self,xmlfile = "ext.xml"):
    def Out (str):
        output = file ("glexthandler.h", "w")
        output.write (str)
        output.close ()
        
    def CreateClass (self,dataset):
        tpl = {}
        tpl[ "constructor" ] = CreateClassConstructor (self, dataset)
        tpl[ "public_members" ] = CreateClassPublicMembers (self, dataset)
        tpl[ "init_functions" ] = CreateClassInitFunctions (self, dataset)
        
        return ProcessTemplate ("class", tpl)
    
    def CreateFlagStruct (self,dataset):
        tpl = { "load_flags" : "",
                "check_flags" : "" }
    
        i = 0.0
        dc = len(dataset)
        for name in dataset:
            i += 1
            self.ProgressCurrent (i/dc*100)
            self.ProgressTotal (90 + i/dc*6)
            self.Update ()
            tpl[ "load_flags" ] += ProcessTemplate ("flag_struct_load_flag", { "ext" : name })
            tpl[ "check_flags" ] += ProcessTemplate ("flag_struct_check_flag", { "ext" : name })
    
        return ProcessTemplate ("flag_struct", tpl)
    
    def CreateClassConstructor (self,dataset):
        return ProcessTemplate ("class_constructor")
    
    def CreateClassPublicMembers (self, dataset):
        ret = ""
        for name, data in dataset.iteritems():
            tpl = { "name" : name,
                    "functions" : "" }
            
            if data[ "flag" ] != True:
                for func in data[ "functions" ]:
                    tpl[ "functions" ] += ProcessTemplate ("class_function_pointer_members",
                                                           { "type" : upper (func),
                                                             "name" : func })
    
            ret += ProcessTemplate ("class_public_members", tpl, data[ "type" ])
            
        return ret
    
    def CreateClassInitFunctions (self,dataset):
        ret = ""
        special_init = [ "WGL_EXT_extensions_string" ]
        for name, data in dataset.iteritems():
            tpl = { "name" : name,
                    "check" : "",
                    "inits" : "" }
            
            if (name in special_init) == False:
                tpl[ "check" ] += ProcessTemplate ("class_check_support", { "name" : name }, data[ "type" ])
            if data[ "flag" ] != True:
                # Funcs to init
                for func in data[ "functions" ]:
                    tpl[ "inits" ] += ProcessTemplate ("class_init_function", { "name" : func,
                                                                     "type" : upper (func) })
    
            ret += ProcessTemplate ("init_func", tpl, data[ "type" ])
            
        return ret
    
    def CreateExtensionHeaders (self, dataset):
        ret = ""
        i = 0.0
        dc = len(dataset)
        for name, data in dataset.iteritems():
            i += 1
            self.ProgressCurrent (i/dc*100)
            self.ProgressTotal (75 + i/dc*15)
            self.Update ()
            defines = CreateDefines (self,data)
            typedefs = GetTypedefs (self,data)
            typedefs += CreateTypedefs (self,data)
            tpl = { "name" : name,
                    "defines" : defines,
                    "typedefs" : typedefs }
    
            ret += ProcessTemplate ("ext_header", tpl, data[ "type" ])
            
        return ret
    
    def CreateDefines (self, extension):
        ret = ""
        if extension[ "token" ] == True:
            for name, value in extension[ "tokens" ].iteritems():
                ret += ProcessTemplate ("define", { "name" : name,
                                                    "value" : value })
    
        return ret
    
    def CreateTypedefs (self, extension):
        ret = ""
        if extension[ "flag" ] == False:
            for name, data in extension[ "functions" ].iteritems():
                ret += ProcessTemplate ("func_typedef", { "name" : upper (name),
                                                     "return" : data[ "return" ],
                                                     "pointer" : data[ "pointer" ],
                                                     "args" : data[ "args" ] })
        return ret
    
    def GetTypedefs (self, extension):
        ret = ""
        if extension[ "typedefs" ] == True:
            for name, type in extension[ "types" ].iteritems():
                ret += ProcessTemplate ("typedef", { "name" : name,
                                                     "uname" : upper (name),
                                                     "type" : type })
        return ret
    ##########################################################################################
    ## Helper stuff, stay away!
    
    def CreateDataTree (self,document):
        # try without...
        #special_ext = [ "GL_version_1_2", "GL_version_1_3" ] # WGL_Extension_string_ARB will be
        #                                                     # treated as a normal extension
    
        extensions = {}
        registered_tokens = list()
        registered_functions = list()
        registered_types = list()
        i = 0.0
        ext_count = len(document.getElementsByTagName ("extension"))
        self.ProgressCaption ("Preprocessing %i extensions..." % ext_count)
        for extension in document.getElementsByTagName ("extension"):
            i += 1
            self.ProgressCurrent (i/ext_count*100)
            self.ProgressTotal (10 + i/ext_count*65)
            self.Update ()
            #if extension.getAttribute ("name") in special_ext:
            #    continue
    
            if extensions.has_key (extension.getAttribute ("name")):
                self.Print ("Extension \"%s\" already defined, skipping..." % extension.getAttribute ("name"))
    
            extensions[ extension.getAttribute ("name") ] = {}  # Reset
    
            extensions[ extension.getAttribute ("name") ][ "type" ] = extension.getAttribute ("type")
                        
            self.Print ("Ext: %s" % extension.getAttribute ("name"))
    
            if len (extension.getElementsByTagName ("token")) == 0:
                self.Print ("... no tokens")
                extensions[ extension.getAttribute ("name") ][ "token" ] = False
            else:
                tokens = {}
                for token in extension.getElementsByTagName ("token"):
                    if token.getAttribute ("name") in registered_tokens:
                        self.Print ("Token \"%s\" already defined, skipping..." % token.getAttribute ("name"))
                        continue
                    registered_tokens.append (token.getAttribute ("name"))
                    
                    tokens[ token.getAttribute ("name") ] = token.getAttribute ("value")                
    
                # Has tokens, so it's not a plain flag extension (token = true)
                extensions[ extension.getAttribute ("name") ][ "token" ] = True
                extensions[ extension.getAttribute ("name") ][ "tokens" ] = tokens
    
                self.Print ("... %i tokens" % len (tokens) )
    
            if len (extension.getElementsByTagName ("typedef")) == 0:
                self.Print ("... no typedefs")
                extensions[ extension.getAttribute ("name") ][ "typedefs" ] = False
            else:
                types = {}
                for token in extension.getElementsByTagName ("typedef"):
                    if token.getAttribute ("name") in registered_types:
                        self.Print ("Type \"%s\" already defined, skipping..." % token.getAttribute ("name"))
                        continue
                    registered_tokens.append (token.getAttribute ("name"))
                    
                    types[ token.getAttribute ("name") ] = token.getAttribute ("type")                
    
                # Has tokens, so it's not a plain flag extension (token = true)
                extensions[ extension.getAttribute ("name") ][ "typedefs" ] = True
                extensions[ extension.getAttribute ("name") ][ "types" ] = types
    
                self.Print ("... %i typedefs" % len (types))
    
            if len (extension.getElementsByTagName ("function")) == 0:
                # Assume a flag extension
                self.Print ("... no functions")
                extensions[ extension.getAttribute ("name") ][ "flag" ] = True
            else:
                extensions[ extension.getAttribute ("name") ][ "flag" ] = False
                
                functions = {}
                for function in extension.getElementsByTagName ("function"):
                    if function.getAttribute ("name") in registered_functions:
                        self.Print ("Function \"%s\" already defined, skipping..." % function.getAttribute ("name"))
                        continue
                    registered_functions.append (function.getAttribute ("name"))
    
                    pointer = ""
                    if function.getAttribute ("pointer") == "true": pointer = "*"
                    
                    functions[ function.getAttribute ("name") ] = {
                        "return" : function.getAttribute ("return"),
                        "args"   : ProcessFunctionArguments (function.getElementsByTagName ("argument")),
                        "pointer": pointer }
    
                extensions[ extension.getAttribute ("name") ][ "functions" ] = functions
    
                self.Print ("... %i functions" % len (functions))
    
        return extensions
    
    def ProcessFunctionArguments (arglist):
        arglist_len = len( arglist )
    
        if( arglist_len == 0 ):
            return "";
    
        args = {}
        ret = ""
        for index, arg in enumerate (arglist):
            if arg.getAttribute ("const") == "true":
                args[ "const" ] = "const "
            else:
                args[ "const" ] = ""
    
            if arg.getAttribute ("const_pointer") == "true":
                args[ "const_pointer" ] = " const"
            else:
                args[ "const_pointer" ] = ""
                
            args[ "type" ] = arg.getAttribute ("type")
            
            if arg.getAttribute ("pointer") == "true":
                args[ "pointer" ] = "*"
            else:
                args[ "pointer" ] = ""
                
            args[ "name" ] = arg.getAttribute ("name")
            
            if index != arglist_len - 1:
                args[ "seperator" ] = ", "
            else:
                args[ "seperator" ] = ""
    
            ret += ProcessTemplate ("argument_list_item",args)
    
        return ret   
    
    def ProcessTemplate (filename, variables = {}, type = ""):
        tpl = GetTemplateFile( filename, type )
        for k,v in variables.iteritems():
            tpl = replace( tpl, "%" + upper(k) + "%", v )
        return tpl
    
    def GetTemplateFile (filename, type):
        if (type != "") and (type != "GL"):
            type = "_" + string.lower (type)
        else:
            type = "" # if type was GL
            
        return file("./templates/" + filename + type + ".txt", "r").read()
    
    self.ProgressCaption ("Loading/Parsing file")
    self.Print ("Loading file...")
    ext_file = file( xmlfile, "r" )
    str = ext_file.read()
    self.Print ("...done")
    self.ProgressTotal (1)
    self.ProgressCurrent (25)
    
    self.Print ("Parsing file...")
    dom = minidom.parseString(str)
    self.Print ("...done")
    self.ProgressTotal (10)
    self.ProgressCurrent (100)

    self.ProgressCaption ("Preprocessing data...")
    self.ProgressCurrent (0)
    self.Refresh ()
    data = CreateDataTree (self, dom)
    self.Print ("...done")
    self.ProgressCurrent (100)
    
    tpl = {}

    self.ProgressCaption ("Creating extension headers...")
    self.ProgressCurrent (0)
    self.Print ("Creating extension headers...")
    tpl[ "extension_headers" ] = CreateExtensionHeaders (self, data)
    
    self.ProgressCaption ("Creating extension flag struct...")
    self.ProgressCurrent (0)
    self.Print ("...done, creating extension flag struct...")
    tpl[ "flag_struct" ] = CreateFlagStruct (self, data)
    
    self.ProgressCaption ("Creating extension handler class...")
    self.Update ()
    
    self.Print ("...done, creating extension handler class...")
    self.ProgressCurrent (0)
    tpl[ "class" ] = CreateClass (self, data)
    self.ProgressTotal (98)
    self.ProgressCurrent (100)
    self.Print ("...done")

    self.ProgressCaption ("Writing file...")
    self.Print ("Writing file...")
    self.ProgressCurrent (0)
    Out (ProcessTemplate ("file", tpl))
    self.Print ("...done")
    self.ProgressTotal (100)
    self.ProgressCurrent (100)
    self.ProgressCaption ("Done")
    
    



# Create XML from registry
def CreateXML (self):
    # globals, for error reporting
    current_file = ""
    current_line = 0
    
    def ParseExtensionDescription (self,data ):
        ext_data = {}
        ext_data[ "name" ] = string.rstrip(data[0], "\n")
    
        name_s = string.split( ext_data[ "name" ], "_" )
    
        ext_data[ "type" ] = name_s[0]
        ext_data[ "subtype" ] = name_s[1]
        
        start_index = 1
    
        # has some URL?
        if string.find(data[1], "http://") == 0:
            ext_data[ "url" ] = string.rstrip(data[1], "\n")
            start_index += 1
    
        tokens = list()
        typedefs = list()
        functions = list()
        unknown = list()
    
        for linenumber, line in enumerate(data[start_index:]):
            line = string.strip(line)
            if line == "":
                continue    # skip blank lines
            
            current_line = linenumber + start_index - 1
            current_file = string.strip (data[0])
            # early out if extern
            # what the hell has an external function lost inside the spec?
            # only one I saw was glXGetProcAddress
            if string.find(line, "extern") == 0:
                self.Print ("WARN: extern found in file: %s, line: %i: " % (current_file, current_line))
                self.Print ("=> " + line)
                self.Print ("   ... skipped")
                continue
            
            # check whether it's a token definition or a function
            # layman's check
            # if token definition, we have a string with A-Z_0-9 (.*)
            match = re.match("([A-Z_0-9]+)\s+(\S+)$", line)
            if match:
                # A token definition
                token = match.group(1)
                value = match.group(2)
                tokens.append ({ "token" : token, "value" : value })
                continue
    
            # Not a token, try whether it's a typedef
            match = re.match("typedef\s*(.*)", line)
            if match:
                tn = string.split(match.group(1))
                l = len (tn)
    
                type = ""
                name = ""
    
                if tn[1][0] == "(":
                    # typedef ( * name )( paramters )
                    # get the whole "type (*name)(parameters)" string
                    fn_td = string.strip(match.group(1))
                    # now, split this in two:
                    # 1: name
                    # 2: parameter list
                    fn_td_data = re.match( "([^(]+)[*(\s]+(\S+)[\s)]+[(\s]+(.*)[)\s](const)?", fn_td )
                    return_type = string.strip (fn_td_data.group(1))
                    name = string.strip (fn_td_data.group(2))
                    args = string.strip (string.strip (fn_td_data.group(3)), "()") # sometimes a ) remains...
                    const = string.strip (fn_td_data.group(4))
    
                    fun = ParseFunction (return_type, name, args, const)
    
                    typedefs.append ({ "function_pointer" : fun, "name" : name })
                else:                
                    for i, tk in enumerate (tn):
                        if i != l - 1:
                            type += tk
                            if i != l - 2:
                                type += " "
                        else:
                            name = tk
    
                    # not handled: typedef type a, b
    
                    typedefs.append ({ "type" : type, "name" : name })
    
                continue
    
            match = re.match("(.+)\s+(\S+)\s*\((.*)\)\s*(const)?", line)
            if match:
                # print line
                return_value = match.group (1)
                functions.append (ParseFunction (return_value, match.group(2), match.group(3), match.group(4)))
                continue
    
            self.Print ("INFO: Unknown line (no match) in file: %s, line: %i" % (current_file, current_line))
            self.Print ("=> " + line)
    
            unknown.append (line)
    
        ext_data[ "tokens" ] = tokens
        ext_data[ "functions" ] = functions
        ext_data[ "typedefs" ] = typedefs
        ext_data[ "unknown" ] = unknown
            
        return ext_data
    
    def ParseFunction( return_type, name, parameter_list, const_func ):
        fun = {}
        
        fun[ "arguments" ] = ParseArgumentList (parameter_list)
        fun[ "return" ] = string.strip (return_type) # see below
        fun[ "name" ] = string.strip (name) # in case a " " slips through
    
        if const_func == "const":
            fun[ "const" ] = "true"
        else:   # const_func == ""
            fun[ "const" ] = "false"
            
        return fun
    
    def ParseArgumentList (parameter_list):
        parameters = list()
        plist = string.split(parameter_list, ",")
    
        for pitem in plist:
            fun = {}
    
            # strip whitespace
            pitem = string.strip(pitem)
    
            # How many pointers? (*)
            pointers = string.count(pitem, "*")
    
            if pointers > 0:
                fun[ "pointer" ] = "true"
                # strip all pointers - they'll be added back later
                pitem = string.replace(pitem, "*", "")
            else:
                fun[ "pointer" ] = "false"
    
            
            consts = string.count(pitem, "const")
    
            if consts == 1:
                if pitem[:5] == "const":    # starts with const?
                    fun[ "const" ] = "true"
                else:                       # no, so it must be a const pointer
                    fun[ "const_pointer" ] = "true"
            elif consts == 2:
                fun[ "const" ] = "true"
                fun[ "const_pointer" ] = "true"
            elif consts > 2:
                #error
                self.Print ("ERROR: Too many \"const\" in file: %s, line: %i" % (current_file, current_line))
                self.Print ("=> %i const found, max 2 expected" % consts)
                pass
    
            if consts > 0:
                pitem = string.replace(pitem, "const", "")
    
            # note that type * name is impossible now, as all * are stripped
            # const is also away
            spl = string.split(string.strip(pitem))
    
            l = len(spl)
    
            if l == 0:
                self.Print ("ERROR: Invalid function definition: %s, line: %i" % (current_file, current_line))
                self.Print ("=> \"%s\"") % pitem
                continue    # empty paramter list
                            # might be const * const * or something like that
                            # but can't be valid code
    
            # three cases
            if l == 1:
                # type
                fun[ "type" ] = spl[0]
            elif l == 2:
                # type name
                # unsigned type
                if spl[0] == "signed" or spl[0] == "unsigned" or spl[0] == "short" or spl[0] == "long":
                    fun[ "type" ] = spl[0] + " " + spl[1]
                else:
                    fun[ "type" ] = spl[0]
                    fun[ "name" ] = spl[1]
            elif l == 3 or l == 4:
                # unsigned type name
                # unsigned short type name
                fun[ "type" ] = spl[0]
                for i in range(1,l-1):
                    fun[ "type" ] += " " + spl[i]
    
                fun[ "name" ] = spl[l-1]
            else:
                # error
                self.Print ("ERROR: Too many function parameters in file: %s, line: %i" % (current_file, current_line))
                self.Print ("=> \"%s\"" % pitem)
                pass
    
            # do this first in case no name, but > 1 pointer
            if fun.has_key ("name") == False:
                fun[ "name" ] = "" # <arg name="">
            
            if pointers > 1:
                ptr = ""
                for i in range(1, pointers):
                   ptr += "*"
                fun[ "name" ] = ptr + fun[ "name" ]
    
            # now, set things that may not have been set above
            if fun.has_key ("const") == False:
                fun[ "const" ] = "false"
                
            if fun.has_key ("const_pointer") == False:
                fun[ "const_pointer" ] = "false"
    
            parameters.append(fun)
            
        return parameters 
    
    
    impl = getDOMImplementation()
    
    doc = impl.createDocument(None, "extensions", None)
    root = doc.documentElement
    root.appendChild (doc.createComment (
        """Source files (C) SGI Extension registry
    Extension files from GLEW (glew.sf.net)
    Generated by glext2.py by Matthaeus G. "Anteru" Chajdas
    ( Anteru@developer.shelter13.net )
    
    Version 1.0
    
    Feel free to use this XML for your extension handling code
    Just don't forget to give me credits"""))
    
    extensions_list = listdir ("./extensions")
    available_extensions = list ()
	
    for ext in extensions_list:
        if path.isfile ("./extensions/" + ext) == False:
            continue
        
        available_extensions.append (ext)
    
    available_extensions.sort ()
    ext_count = len (available_extensions)
    i = 0.0
    
    root.appendChild (doc.createComment ("Extensions count: %i" % ext_count))
    self.ProgressCaption ("Processing %i extensions..." % ext_count)
    for i, ext in enumerate (available_extensions):
        i += 1
        self.ProgressCurrent (i/float(ext_count)*100)
        self.ProgressTotal (i/float(ext_count)*95)
        self.Update ()
        
        if path.isfile ("./extensions/" + ext) == False:
            continue
        
        ext_file = file ("./extensions/" + ext, "r")
        ext_file_c = ext_file.readlines ()               #content of extension file
        ext_file.close ()                                #close it
    
        el = doc.createElement ("extension")
        ext = ParseExtensionDescription (self,ext_file_c)
    
        el.setAttribute ("name", ext[ "name" ])
    
        self.Print ("Processing extension: " + ext["name"])
    
        if ext.has_key ("url"):
            el.setAttribute ("url", ext[ "url" ])
    
        el.setAttribute ("type", ext[ "type" ])
        el.setAttribute ("subtype", ext[ "subtype" ])
    
        if len (ext[ "tokens" ]) > 0:
            self.Print ("... tokens")
            el.appendChild (doc.createComment ("Token count: %i" % len (ext[ "tokens" ])))
            for token in ext[ "tokens" ]:
                tk = doc.createElement ("token")
                tk.setAttribute ("name", token[ "token" ])
                tk.setAttribute ("value", token[ "value" ])
                el.appendChild (tk)
    
        if len (ext[ "typedefs" ]) > 0:
            self.Print ("... typedefs")
            el.appendChild (doc.createComment ("Typedefs count: %i" % len (ext[ "typedefs" ])))
            for typedef in ext[ "typedefs" ]:
                td = doc.createElement ("typedef")
                if typedef.has_key ("type"):
                    td.setAttribute ("type", typedef[ "type" ])
                    td.setAttribute ("name", typedef[ "name" ])
                    td.setAttribute ("function_pointer", "false")
                else:
                    td.setAttribute ("name", typedef[ "name" ])
                    td.setAttribute ("function_pointer", "true")
                    fc = doc.createElement ("function")
                    fc.setAttribute ("name", typedef[ "function_pointer" ][ "name" ])
                    fc.setAttribute ("return", typedef[ "function_pointer" ][ "return" ])
                    fc.setAttribute ("const", typedef[ "function_pointer" ][ "const" ])
                    
                    if len (typedef[ "function_pointer" ][ "arguments" ]) > 0:
                        for argument in typedef[ "function_pointer" ][ "arguments" ]:
                            arg = doc.createElement ("argument")
                            arg.setAttribute ("name", argument[ "name" ])
                            arg.setAttribute ("pointer", argument[ "pointer" ])
                            arg.setAttribute ("const", argument[ "const" ])
                            arg.setAttribute ("const_pointer", argument[ "const_pointer" ])
                            arg.setAttribute ("type", argument[ "type" ])
                            fc.appendChild (arg)
                        
                    td.appendChild (fc)
    
                el.appendChild (td)
    
        if len (ext[ "functions" ]) > 0:
            self.Print ("... functions")
            el.appendChild (doc.createComment ("Functions count: %i" % len (ext[ "functions" ])))
            for function in ext[ "functions" ]:
                fc = doc.createElement ("function")
                fc.setAttribute ("name", function[ "name" ])
                fc.setAttribute ("return", function[ "return" ])
                fc.setAttribute ("const", function[ "const" ])
    
                if len (function[ "arguments" ]) > 0:
                    for argument in function[ "arguments" ]:
                        arg = doc.createElement ("argument")
                        arg.setAttribute ("name", argument[ "name" ])
                        arg.setAttribute ("pointer", argument[ "pointer" ])
                        arg.setAttribute ("const", argument[ "const" ])
                        arg.setAttribute ("const_pointer", argument[ "const_pointer" ])
                        arg.setAttribute ("type", argument[ "type" ])
                        fc.appendChild (arg)
                el.appendChild (fc)
                
        if len (ext[ "unknown" ]) > 0:
            self.Print ("... unknown/special")
            el.appendChild (doc.createComment ("Unknown, no match"))
            for unknown in ext[ "unknown" ]:
                un = doc.createElement ("unknown")
                un.setAttribute ("value", unknown)
    
                el.appendChild (un)      
        
        root.appendChild (el)

    x = file("ext.xml", "w")
    self.ProgressCaption ("Creating XML...")
    self.Print ("Processing XML")
    d = doc.toprettyxml()
    self.Print ("...done")
    self.ProgressTotal (98)
    self.ProgressCaption ("Writing file...")
    self.Print ("Writing file...")
    x.write (d)
    x.close ()
    self.Print ("...done")
    self.ProgressCaption ("Done")
    self.ProgressTotal (100)





    
